version: "3.8"

services:

  alpha:
    image: mysql/mysql-server:8.0
    container_name: alpha
    hostname: alpha
    ports:
      - '33016:3306'
    restart: unless-stopped
    # sets the network address which the member provides for connections from other members, specified as a host:port formatted string.
    command: [ 'mysqld',
               '--server_id=1',
               '--loose-group-replication-local-address=alpha:6606',
               '--character-set-server=utf8mb4',
               '--collation-server=utf8mb4_unicode_ci',
               '--innodb-buffer-pool-size=1000M']
    environment:
      MYSQL_ROOT_HOST: '%'
      MYSQL_DATABASE: social-network
      MYSQL_PASSWORD: password
      MYSQL_ROOT_PASSWORD: root
      MYSQL_USER: user
    volumes:
      - ./conf/my-cnf:/etc/mysql/my.cnf
      - ./scripts:/docker-entrypoint-initdb.d
    healthcheck:
      test: "mysqladmin ping -u root -p$${MYSQL_ROOT_PASSWORD}"
      interval: 2s
      retries: 20

  beta:
    image: mysql/mysql-server:8.0
    container_name: beta
    hostname: beta
    ports:
      - '33026:3306'
    restart: unless-stopped
    # sets the network address which the member provides for connections from other members, specified as a host:port formatted string.
    command: [ 'mysqld',
               '--server_id=2',
               '--loose-group-replication-local-address=beta:6606',
               '--character-set-server=utf8mb4',
               '--collation-server=utf8mb4_unicode_ci',
               '--innodb-buffer-pool-size=1000M']
    environment:
      MYSQL_ROOT_HOST: '%'
      MYSQL_DATABASE: social-network
      MYSQL_PASSWORD: password
      MYSQL_ROOT_PASSWORD: root
      MYSQL_USER: user
    volumes:
      - ./conf/my-cnf:/etc/mysql/my.cnf
      - ./scripts:/docker-entrypoint-initdb.d
    healthcheck:
      test: "mysqladmin ping -u root -p$${MYSQL_ROOT_PASSWORD}"
      interval: 2s
      retries: 20

  gamma:
    image: mysql/mysql-server:8.0
    container_name: gamma
    hostname: gamma
    ports:
      - '33036:3306'
    restart: unless-stopped
    # sets the network address which the member provides for connections from other members, specified as a host:port formatted string.
    command: [ 'mysqld',
               '--server_id=3',
               '--loose-group-replication-local-address=gamma:6606',
               '--character-set-server=utf8mb4',
               '--collation-server=utf8mb4_unicode_ci',
               '--innodb-buffer-pool-size=1000M']
    environment:
      MYSQL_ROOT_HOST: '%'
      MYSQL_DATABASE: social-network
      MYSQL_PASSWORD: password
      MYSQL_ROOT_PASSWORD: root
      MYSQL_USER: user
    volumes:
      - ./conf/my-cnf:/etc/mysql/my.cnf
      - ./scripts:/docker-entrypoint-initdb.d
    healthcheck:
      test: "mysqladmin ping -u root -p$${MYSQL_ROOT_PASSWORD}"
      interval: 2s
      retries: 20
